VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMain 
   Caption         =   "Rodokmen"
   ClientHeight    =   4770
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   7200
   LinkTopic       =   "Form1"
   ScaleHeight     =   4770
   ScaleWidth      =   7200
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ListView lvwRod 
      Height          =   4620
      Left            =   45
      TabIndex        =   0
      Top             =   105
      Width           =   7110
      _ExtentX        =   12541
      _ExtentY        =   8149
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      AllowReorder    =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   7
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Key             =   "jmeno"
         Text            =   "Jmno"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Key             =   "prijmeni"
         Text            =   "Pjmen"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Key             =   "pohlavi"
         Text            =   "Pohlav"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Key             =   "narozeni"
         Text            =   "Narozen"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(5) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   4
         Key             =   "umrti"
         Text            =   "mrt"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(6) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   5
         Key             =   "matka"
         Text            =   "Matka"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(7) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   6
         Key             =   "otec"
         Text            =   "Otec"
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.Menu mnuSoubor 
      Caption         =   "&Soubor"
      Begin VB.Menu mnuImport 
         Caption         =   "&Import"
         Shortcut        =   ^I
         Visible         =   0   'False
      End
      Begin VB.Menu mnuExport 
         Caption         =   "&Export"
         Shortcut        =   ^E
      End
      Begin VB.Menu mnuX1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuZavrit 
         Caption         =   "&Zavt"
      End
   End
   Begin VB.Menu mnuObjekt 
      Caption         =   "&Osoba"
      Begin VB.Menu mnuPridatOsobu 
         Caption         =   "&Pidat osobu"
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuOdebratOsobu 
         Caption         =   "&Odebrat osobu"
         Shortcut        =   {DEL}
      End
   End
   Begin VB.Menu mnuZobrazit 
      Caption         =   "&Zobrazit"
      Begin VB.Menu mnuObnovit 
         Caption         =   "&Obnovit"
         Shortcut        =   {F5}
      End
   End
   Begin VB.Menu mnuNapoveda 
      Caption         =   "Npo&vda"
      Begin VB.Menu mnuObsah 
         Caption         =   "O&bsah"
         Shortcut        =   {F1}
      End
      Begin VB.Menu mnuOProgramu 
         Caption         =   "&O programu"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Soutezni cislo: 10 - starsi zaci
' Email: mcr@mw.jikos.cz

Option Explicit

' Pole pro prirazeni objektu v kolekci Items k polozkam v ListView
Dim Polozky() As clsItem

' Objekt pro praci se soubory
Dim Fso As New FileSystemObject

'Pro uchovavani souradnic mysi
Dim CurX As Single, CurY As Single

' Vytvori XML ze vsech objektu
Public Function Export() As String
  Dim CurItem As clsItem
  Export = ""
  For Each CurItem In Items
    If Not CurItem.Odstraneno Then
      Export = Export & CurItem.Export
    End If
  Next
  Export = CatTag("rodokmen", Export, 0, True)
End Function

' Rutina pro export do souboru (vyuziva Export())
Private Sub ExportFile()
  On Error GoTo ErrHandle
  Dim FileName As String
  Dim ExportStream As TextStream
  FileName = InputBox("Zadejte nzev souboru pro export:", "Export", "G:\Rodokmen.xml")
  If FileName = "" Then Exit Sub
  If Fso.FileExists(FileName) Then
    If Not MsgBox("Soubor ji existuje. Chcete ho pepsat?", vbInformation + vbYesNo) = vbYes Then
      Exit Sub
    End If
  End If
  Set ExportStream = Fso.CreateTextFile(FileName, True, False)
  ExportStream.Write Export()
  ExportStream.Close
  Set ExportStream = Nothing
  Exit Sub
ErrHandle:
  MsgBox "Soubor se nepodailo zapsat!", vbCritical
  Err.Clear
  Exit Sub
End Sub

'Vymaze a vytvori znovu obsah ListView podle Items
Public Sub Obnovit()
  Dim CurItem As clsItem
  lvwRod.ListItems.Clear
  ReDim Polozky(1)
  For Each CurItem In Items
    If Not CurItem.Odstraneno Then
      lvwRod.ListItems.Add , , CurItem.Jmeno
    
      If UBound(Polozky) < lvwRod.ListItems.Count Then
        ReDim Preserve Polozky(lvwRod.ListItems.Count)
      End If
      Set Polozky(lvwRod.ListItems.Count) = CurItem
    
      With lvwRod.ListItems(lvwRod.ListItems.Count).ListSubItems
        .Add , "prijmeni", CurItem.Prijmeni
        .Add , "pohlavi", IIf(CurItem.Pohlavi = Neurceno, "", IIf(CurItem.Pohlavi = Muz, "mu", "ena"))
        .Add , "narozeni", CurItem.Narozeni
        .Add , "umrti", CurItem.Umrti
        If Not CurItem.Matka Is Nothing Then
          .Add , "matka", CurItem.Matka.Prijmeni & " " & CurItem.Matka.Jmeno
        End If
        If Not CurItem.Otec Is Nothing Then
          .Add , "otec", CurItem.Otec.Prijmeni & " " & CurItem.Otec.Jmeno
        End If
      End With
    End If
  Next
End Sub

Private Sub Edit(LItem As ListItem)
  Load frmOsoba
  Set frmOsoba.Polozka = Polozky(LItem.Index)
  frmOsoba.Init
  frmOsoba.Show vbModal, Me
End Sub

Private Sub lvwRod_DblClick()
  Dim CurLVItem As ListItem
  'Workaround kvuli neexistenci lvwRod_ItemDblClick
  Set CurLVItem = lvwRod.HitTest(CurX, CurY)
  If Not CurLVItem Is Nothing Then
    Edit CurLVItem
  End If
End Sub

Private Sub lvwRod_KeyPress(KeyAscii As Integer)
  If KeyAscii = vbKeyReturn Then
    If Not lvwRod.SelectedItem Is Nothing Then
      Edit lvwRod.SelectedItem
    End If
  End If
End Sub

Private Sub lvwRod_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
  'Workaround kvuli neexistenci lvwRod_ItemDblClick
  CurX = x
  CurY = y
End Sub

Private Sub mnuExport_Click()
  ExportFile
End Sub

Private Sub mnuObnovit_Click()
  Obnovit
End Sub

Private Sub mnuObsah_Click()
  MsgBox "Nedostatek asu na implementaci, sorry! :-(", vbExclamation
End Sub

Private Sub mnuOdebratOsobu_Click()
  Dim Answer As VbMsgBoxResult
  Answer = MsgBox("Opravdu chcete osobu odstranit?", vbInformation Or vbYesNo)
  If Not Answer = vbYes Then Exit Sub
  Polozky(lvwRod.SelectedItem.Index).Odstraneno = True
  Obnovit
End Sub

Private Sub mnuOProgramu_Click()
  MsgBox "Rodokmen" & vbCrLf & "loha pro Mistrovstv R soute dt a mldee v programovn, Hradec Krlov, 15.6.2002" & vbCrLf & "Soutc . 10 - star ci", vbInformation, "O programu Rodokmen"
End Sub

Private Sub mnuPridatOsobu_Click()
  Load frmOsoba
  frmOsoba.Init
  frmOsoba.Show vbModal, Me
End Sub
